com.fasterxml.jackson.databind.deser.std

## Class EnumMapDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase<EnumMap<?,?>>
      - - com.fasterxml.jackson.databind.deser.std.EnumMapDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, NullValueProvider, ResolvableDeserializer, ValueInstantiator.Gettable, Serializable

      public class EnumMapDeserializer
      extends ContainerDeserializerBase<EnumMap<?,?>>
      implements ContextualDeserializer, ResolvableDeserializer

  Deserializer for `EnumMap` values.

  Note: casting within this class is all messed up -- just could not figure out a way to properly deal with recursive definition of `EnumMap<K extends Enum<K>, V>`

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JsonDeserializer<Object>` | `_delegateDeserializer` Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.
    `protected Class<?>` | `_enumClass`
    `protected KeyDeserializer` | `_keyDeserializer`
    `protected PropertyBasedCreator` | `_propertyBasedCreator` If the Map is to be instantiated using non-default constructor or factory method that takes one or more named properties as argument(s), this creator is used for instantiation.
    `protected JsonDeserializer<Object>` | `_valueDeserializer`
    `protected ValueInstantiator` | `_valueInstantiator`
    `protected TypeDeserializer` | `_valueTypeDeserializer` If value instances have polymorphic type information, this is the type deserializer that can handle it

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase

      `_containerType, _nullProvider, _skipNullValues, _unwrapSingle`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `EnumMapDeserializer(EnumMapDeserializer base, KeyDeserializer keyDeser, JsonDeserializer<?> valueDeser, TypeDeserializer vtd, NullValueProvider nuller)`
    `` | `EnumMapDeserializer(JavaType mapType, KeyDeserializer keyDeser, JsonDeserializer<?> valueDeser, TypeDeserializer vtd)` Deprecated.
    `` | `EnumMapDeserializer(JavaType mapType, ValueInstantiator valueInst, KeyDeserializer keyDeser, JsonDeserializer<?> valueDeser, TypeDeserializer vtd, NullValueProvider nuller)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `EnumMap<?,?>` | `_deserializeUsingProperties(JsonParser p, DeserializationContext ctxt)`
    `protected EnumMap<?,?>` | `constructMap(DeserializationContext ctxt)`
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to finalize setup of this deserializer, when it is known for which property deserializer is needed for.
    `EnumMap<?,?>` | `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `EnumMap<?,?>` | `deserialize(JsonParser p, DeserializationContext ctxt, EnumMap result)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `Object` | `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `JsonDeserializer<Object>` | `getContentDeserializer()` Accesor for deserializer use for deserializing content values.
    `Object` | `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
    `boolean` | `isCachable()` Because of costs associated with constructing Enum resolvers, let's cache instances by default.
    `void` | `resolve(DeserializationContext ctxt)` Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller.
    `EnumMapDeserializer` | `withResolved(KeyDeserializer keyDeserializer, JsonDeserializer<?> valueDeserializer, TypeDeserializer valueTypeDeser, NullValueProvider nuller)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase

      `findBackReference, getContentType, getEmptyAccessPattern, getValueInstantiator, getValueType, supportsUpdate, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserializeWithType, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _enumClass

          protected final Class<?> _enumClass

    - #### _keyDeserializer

          protected KeyDeserializer _keyDeserializer

    - #### _valueDeserializer

          protected JsonDeserializer<Object> _valueDeserializer

    - #### _valueTypeDeserializer

          protected final TypeDeserializer _valueTypeDeserializer

      If value instances have polymorphic type information, this is the type deserializer that can handle it

    - #### _valueInstantiator

          protected final ValueInstantiator _valueInstantiator

      Since:
        2.9

    - #### _delegateDeserializer

          protected JsonDeserializer<Object> _delegateDeserializer

      Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.

    - #### _propertyBasedCreator

          protected PropertyBasedCreator _propertyBasedCreator

      If the Map is to be instantiated using non-default constructor or factory method that takes one or more named properties as argument(s), this creator is used for instantiation.

  - ### Constructor Detail

    - #### EnumMapDeserializer

          public EnumMapDeserializer(JavaType mapType,
                                     ValueInstantiator valueInst,
                                     KeyDeserializer keyDeser,
                                     JsonDeserializer<?> valueDeser,
                                     TypeDeserializer vtd,
                                     NullValueProvider nuller)

      Since:
        2.9

    - #### EnumMapDeserializer

          protected EnumMapDeserializer(EnumMapDeserializer base,
                                        KeyDeserializer keyDeser,
                                        JsonDeserializer<?> valueDeser,
                                        TypeDeserializer vtd,
                                        NullValueProvider nuller)

      Since:
        2.9

    - #### EnumMapDeserializer

          @Deprecated
          public EnumMapDeserializer(JavaType mapType,
                                                 KeyDeserializer keyDeser,
                                                 JsonDeserializer<?> valueDeser,
                                                 TypeDeserializer vtd)

      Deprecated.

  - ### Method Detail

    - #### withResolved

          public EnumMapDeserializer withResolved(KeyDeserializer keyDeserializer,
                                                  JsonDeserializer<?> valueDeserializer,
                                                  TypeDeserializer valueTypeDeser,
                                                  NullValueProvider nuller)

    - #### resolve

          public void resolve(DeserializationContext ctxt)
                       throws JsonMappingException

      Description copied from interface: `ResolvableDeserializer`
      Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller. Called object can then resolve its dependencies to other types, including self-references (direct or indirect).
      Specified by:
        `resolve` in interface `ResolvableDeserializer`
      Parameters:
        `ctxt` - Context to use for accessing configuration, resolving secondary deserializers
      Throws:
        `JsonMappingException`

    - #### createContextual

          public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                      BeanProperty property)
                                               throws JsonMappingException

      Method called to finalize setup of this deserializer, when it is known for which property deserializer is needed for.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### isCachable

          public boolean isCachable()

      Because of costs associated with constructing Enum resolvers, let's cache instances by default.
      Overrides:
        `isCachable` in class `JsonDeserializer<EnumMap<?,?>>`

    - #### getContentDeserializer

          public JsonDeserializer<Object> getContentDeserializer()

      Description copied from class: `ContainerDeserializerBase`
      Accesor for deserializer use for deserializing content values.
      Specified by:
        `getContentDeserializer` in class `ContainerDeserializerBase<EnumMap<?,?>>`

    - #### getEmptyValue

          public Object getEmptyValue(DeserializationContext ctxt)
                               throws JsonMappingException

      Description copied from class: `JsonDeserializer`
      Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for specific types. Or, if type should never be converted from empty String, method can also throw an exception.

      This method may be called once, or multiple times, depending on what `JsonDeserializer.getEmptyAccessPattern()` returns.

      Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

      Overrides:
        `getEmptyValue` in class `ContainerDeserializerBase<EnumMap<?,?>>`
      Throws:
        `JsonMappingException`

    - #### deserialize

          public EnumMap<?,?> deserialize(JsonParser p,
                                          DeserializationContext ctxt)
                                   throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (p.currentToken() == JsonToken.START_OBJECT) {
                   p.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<EnumMap<?,?>>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### deserialize

          public EnumMap<?,?> deserialize(JsonParser p,
                                          DeserializationContext ctxt,
                                          EnumMap result)
                                   throws IOException

      Description copied from class: `JsonDeserializer`
      Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

      Overrides:
        `deserialize` in class `JsonDeserializer<EnumMap<?,?>>`
      Throws:
        `IOException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser p,
                                            DeserializationContext ctxt,
                                            TypeDeserializer typeDeserializer)
                                     throws IOException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<EnumMap<?,?>>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`

    - #### constructMap

          protected EnumMap<?,?> constructMap(DeserializationContext ctxt)
                                       throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _deserializeUsingProperties

          public EnumMap<?,?> _deserializeUsingProperties(JsonParser p,
                                                          DeserializationContext ctxt)
                                                   throws IOException

      Throws:
        `IOException`

Copyright © 2008–2020 FasterXML. All rights reserved.